/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

import java.util.Map;
import java.util.ArrayList;

/**
 *
 * @author Pan.Pantziarka
 */
public class GridElementStats {

    public Map<String, NeatCell> eaCells;
    //all cell counts
    private final NeatCell normalCell;
    private final GridElement gElement;
    private final int maxCellCount;
    public int healthyNormal;
    public int healthyMalignant;
    public int healthy;
    public int normal;
    public int malignant;
    public int toBeClearedNormal;
    public int toBeClearedMalignant;
    public int toBeCleared;
    public int apoptoticNormal;
    public int apoptoticMalignant;
    public int apoptotic;
    public int dividingNormal;
    public int dividingMalignant;
    public int dividing;
    public int necroticNormal;
    public int necroticMalignant;
    public int necrotic;
    public int viableMalignant;
    public int viableNormal;
    public int totalCellCount;
    public boolean isNecrotic;
    //all summary values
    public int avg_ageMalignant; // = liftime - tick
    public int min_ageMalignant; // = liftime - tick
    public int max_ageMalignant; // = liftime - tick
    public int avg_ageNormal; // = liftime - tick
    public int min_ageNormal; // = liftime - tick
    public int max_ageNormal; // = liftime - tick
    public double avg_distance;
    public double min_distance;
    public double max_distance;
    public double avg_fitnessMalignant;
    public double min_fitnessMalignant;
    public double max_fitnessMalignant;
    public double avg_fitnessNormal;
    public double min_fitnessNormal;
    public double max_fitnessNormal;
    public int[] avg_geneTargets;
    public int[] min_geneTargets;
    public int[] max_geneTargets;
    public int[] avg_geneTolerance;
    public int[] min_geneTolerance;
    public int[] max_geneTolerance;
    public double avg_invasionRate;
    public double min_invasionRate;
    public double max_invasionRate;
    public int avg_lifeTime;
    public int min_lifeTime;
    public int max_lifeTime;
    public int avg_mutationCount;
    public int min_mutationCount;
    public int max_mutationCount;
    public double avg_mutationRate;
    public double min_mutationRate;
    public double max_mutationRate;
    public int avg_nutrientRate;
    public int min_nutrientRate;
    public int max_nutrientRate;
    public double avg_nutrientStore;
    public double min_nutrientStore;
    public double max_nutrientStore;
    public int avg_nutrientTarget;
    public int min_nutrientTarget;
    public int max_nutrientTarget;
    //lifeTimes is different - needed for median
    public ArrayList<Integer> lifeTimes;
    //denominator selection
    public static String selector;
    public boolean include;
    public int meanDenomMalignant;
    public int meanDenomNormal;

    GridElementStats(GridElement gE, NeatCell norm) {
        normalCell = norm.clone();
        eaCells = gE.eaCells;
        maxCellCount = gE.maxCellCount;
        gElement = gE;
        avg_geneTargets = new int[norm.getGenomeLength()];
        min_geneTargets = new int[norm.getGenomeLength()];
        max_geneTargets = new int[norm.getGenomeLength()];
        avg_geneTolerance = new int[norm.getGenomeLength()];
        min_geneTolerance = new int[norm.getGenomeLength()];
        max_geneTolerance = new int[norm.getGenomeLength()];
        reset();
    }

    public void updateStats(boolean normalOnly) {
        reset();
        selector = "viable"; //either viable or healthy
        for (NeatCell eaCell : eaCells.values()) {
            CellType type = eaCell.getType();
            CellState state = eaCell.getState();
            switch (state) {
                case HEALTHY:
                    if (type == CellType.NORMAL) {
                        healthyNormal++;
                        viableNormal++;
                    } else {
                        healthyMalignant++;
                        viableMalignant++;
                    }
                    healthy++;
                    break;
                case APOPTOTIC:
                    if (type == CellType.NORMAL) {
                        apoptoticNormal++;
                    } else {
                        apoptoticMalignant++;
                    }
                    apoptotic++;
                    break;
                case DIVIDING:
                    if (type == CellType.NORMAL) {
                        dividingNormal++;
                        viableNormal++;
//                        ageNormal+=eaCell.getLifeTime()-eaCell.getClock();                        
                    } else {
                        dividingMalignant++;
                        viableMalignant++;
//                        ageMalignant+=eaCell.getLifeTime()-eaCell.getClock();
                    }
                    dividing++;
                    break;
                case TO_BE_CLEARED:
                    if (type == CellType.NORMAL) {
                        toBeClearedNormal++;
                    } else {
                        toBeClearedMalignant++;
                    }
                    toBeCleared++;
                    break;
                case NECROTIC:
                    if (type == CellType.NORMAL) {
                        necroticNormal++;
                    } else {
                        necroticMalignant++;
                    }
                    necrotic++;
                    break;
            }
            normal = healthyNormal + apoptoticNormal + dividingNormal
                    + toBeClearedNormal; // + necroticNormal;
            malignant = healthyMalignant + apoptoticMalignant + dividingMalignant
                    + toBeClearedMalignant + necrotic; // + necroticMalignant;
            totalCellCount = normal + malignant;

            //decide if counts are  based on viable or healthy malignant
            if (selector == "viable") {
                include = eaCell.isViable();
                meanDenomMalignant = viableMalignant;
                meanDenomNormal = viableNormal;
            } else {
                include = eaCell.isHealthy();
                meanDenomMalignant = healthyMalignant;
                meanDenomNormal = viableNormal;
            }

            //get the age of cells
            if (include) {
                if (type == CellType.NORMAL) {
                    min_ageNormal = Math.min(min_ageNormal,
                            eaCell.getLifeTime() - eaCell.getClock());
                    max_ageNormal = Math.max(max_ageNormal,
                            eaCell.getLifeTime() - eaCell.getClock());
                    avg_ageNormal += ((eaCell.getLifeTime() - eaCell.getClock())
                            - avg_ageNormal) / meanDenomNormal;
                } else {
                    min_ageMalignant = Math.min(min_ageMalignant,
                            eaCell.getLifeTime() - eaCell.getClock());
                    max_ageMalignant = Math.max(max_ageMalignant,
                            eaCell.getLifeTime() - eaCell.getClock());
                    avg_ageMalignant += ((eaCell.getLifeTime() - eaCell.getClock())
                            - avg_ageMalignant) / meanDenomMalignant;
                }
            }

            if (include) {  //isHealthy() or isViable
                double fitness = eaCell.getFitness();
                if (Double.isInfinite(fitness)) {
                    System.out.println(fitness);
                }
                if (!Double.isNaN(fitness)) {
                    if (type == CellType.MALIGNANT) {
                        min_fitnessMalignant = Math.min(min_fitnessMalignant,
                                fitness);
                        max_fitnessMalignant = Math.max(max_fitnessMalignant,
                                fitness);
                        avg_fitnessMalignant += (fitness - avg_fitnessMalignant)
                                / meanDenomMalignant;
                    } else {
                        min_fitnessNormal = Math.min(min_fitnessNormal,
                                fitness);
                        max_fitnessNormal = Math.max(max_fitnessNormal,
                                fitness);
                        avg_fitnessNormal += (fitness - avg_fitnessNormal)
                                / meanDenomNormal;
                    }
                }
            }

            if ((type == CellType.MALIGNANT) && include) {  //was isHealthy
                min_mutationRate = Math.min(min_mutationRate,
                        eaCell.getMutationRate());
                max_mutationRate = Math.max(max_mutationRate,
                        eaCell.getMutationRate());
                avg_mutationRate += (eaCell.getMutationRate() - avg_mutationRate)
                        / meanDenomMalignant;
                min_invasionRate = Math.min(min_invasionRate,
                        eaCell.getInvasionRate());
                max_invasionRate = Math.max(max_invasionRate,
                        eaCell.getInvasionRate());
                avg_invasionRate += (eaCell.getInvasionRate() - avg_invasionRate)
                        / meanDenomMalignant;
                min_distance = Math.min(min_distance,
                        eaCell.getDistance(normalCell));
                max_distance = Math.max(max_distance,
                        eaCell.getDistance(normalCell));
                avg_distance += (eaCell.getDistance(normalCell) - avg_distance)
                        / meanDenomMalignant;
                min_mutationCount = Math.min(min_mutationCount,
                        eaCell.getCumulativeMutationCount());
                max_mutationCount = Math.max(max_mutationCount,
                        eaCell.getCumulativeMutationCount());
                avg_mutationCount += (eaCell.getCumulativeMutationCount() - avg_mutationCount)
                        / meanDenomMalignant;
                min_lifeTime = Math.min(min_lifeTime, eaCell.getLifeTime());
                max_lifeTime = Math.max(max_lifeTime, eaCell.getLifeTime());
                avg_lifeTime += (eaCell.getLifeTime() - avg_lifeTime)
                        / meanDenomMalignant;
                lifeTimes.add(eaCell.getLifeTime());
                min_nutrientTarget = Math.min(min_nutrientTarget, eaCell.getNutrientTarget());
                max_nutrientTarget = Math.max(max_nutrientTarget, eaCell.getNutrientTarget());
                avg_nutrientTarget += (eaCell.getNutrientTarget() - avg_nutrientTarget)
                        / meanDenomMalignant;
                min_nutrientRate = Math.min(min_nutrientRate, eaCell.getNutrientRate());
                max_nutrientRate = Math.max(max_nutrientRate, eaCell.getNutrientRate());
                avg_nutrientRate += (eaCell.getNutrientRate() - avg_nutrientRate)
                        / meanDenomMalignant;
                min_nutrientStore = Math.min(min_nutrientStore, eaCell.getNutrientStore());
                max_nutrientStore = Math.max(max_nutrientStore, eaCell.getNutrientStore());
                avg_nutrientStore += (eaCell.getNutrientStore() - avg_nutrientStore)
                        / meanDenomMalignant;
//                if (eaCell.getNutrientStore() > 100.00){
//                    System.out.println("Here");
//                }
                for (int i = 0; i < avg_geneTargets.length; i++) {
                    min_geneTargets[i] = Math.min(min_geneTargets[i],
                            eaCell.getGeneTarget(i));
                    max_geneTargets[i] = Math.max(max_geneTargets[i],
                            eaCell.getGeneTarget(i));
                    avg_geneTargets[i] += (eaCell.getGeneTarget(i) - avg_geneTargets[i])
                            / meanDenomMalignant;
                    min_geneTolerance[i] = Math.min(min_geneTolerance[i],
                            eaCell.getGeneTolerance(i));
                    max_geneTolerance[i] = Math.max(max_geneTolerance[i],
                            eaCell.getGeneTolerance(i));
                    avg_geneTolerance[i] += (eaCell.getGeneTolerance(i) - avg_geneTolerance[i])
                            / meanDenomMalignant;
                }
            }

            if (normalOnly && include) {
                min_nutrientStore = Math.min(min_nutrientStore, eaCell.getNutrientStore());
                max_nutrientStore = Math.max(max_nutrientStore, eaCell.getNutrientStore());
                avg_nutrientStore += (eaCell.getNutrientStore() - avg_nutrientStore)
                        / meanDenomNormal;
            }

        }

        isNecrotic = gElement.gridIsNecrotic;
//        localHypoxicLevel = Math.exp(-(double) malignant / totalCellCount);

    }

    public int countHealthy() {
        return healthy;
    }

    public int countDividing() {
        return dividing;
    }

    public int countApoptotic() {
        return apoptotic;
    }

    public int countToBeCleared() {
        return toBeCleared;
    }

    public int countNormal() {
        return normal;
    }

    public int countMalignant() {
        return malignant;
    }

    private void reset() {
        //cell counts
        healthyNormal = 0;
        healthyMalignant = 0;
        healthy = 0;
        normal = 0;
        malignant = 0;
        toBeClearedNormal = 0;
        toBeClearedMalignant = 0;
        toBeCleared = 0;
        apoptoticNormal = 0;
        apoptoticMalignant = 0;
        apoptotic = 0;
        dividingNormal = 0;
        dividingMalignant = 0;
        dividing = 0;
        necroticNormal = 0;
        necroticMalignant = 0;
        viableMalignant = 0;
        viableNormal = 0;
        necrotic = 0;
        totalCellCount = 0;
        //summary values
        avg_ageMalignant = 0;
        min_ageMalignant = Integer.MAX_VALUE;
        max_ageMalignant = 0;
        avg_ageNormal = 0;
        min_ageNormal = Integer.MAX_VALUE;
        max_ageNormal = 0;
        avg_distance = 0;
        min_distance = Double.MAX_VALUE;
        max_distance = 0;
        avg_fitnessMalignant = 0;
        min_fitnessMalignant = Double.MAX_VALUE;
        max_fitnessMalignant = 0;
        avg_fitnessNormal = 0;
        min_fitnessNormal = Double.MAX_VALUE;
        max_fitnessNormal = 0;
        avg_geneTargets = new int[avg_geneTargets.length];
        min_geneTargets = new int[min_geneTargets.length];
        max_geneTargets = new int[max_geneTargets.length];
        avg_geneTolerance = new int[avg_geneTolerance.length];
        min_geneTolerance = new int[min_geneTolerance.length];
        max_geneTolerance = new int[max_geneTolerance.length];
        avg_invasionRate = 0;
        min_invasionRate = Double.MAX_VALUE;
        max_invasionRate = 0;
        avg_lifeTime = 0;
        min_lifeTime = Integer.MAX_VALUE;
        max_lifeTime = 0;
        avg_mutationCount = 0;
        min_mutationCount = Integer.MAX_VALUE;
        max_mutationCount = 0;
        avg_mutationRate = 0;
        min_mutationRate = Double.MAX_VALUE;
        max_mutationRate = 0;
        avg_nutrientRate = 0;
        min_nutrientRate = Integer.MAX_VALUE;
        max_nutrientRate = 0;
        avg_nutrientStore = 0;
        min_nutrientStore = Double.MAX_VALUE;
        max_nutrientStore = 0;
        avg_nutrientTarget = 0;
        min_nutrientTarget = Integer.MAX_VALUE;
        max_nutrientTarget = 0;
        lifeTimes = new ArrayList<>();
        selector = "viable";
        include = false;
        meanDenomMalignant = 0;
        meanDenomNormal = 0;
    }

    public String txtPrint() {
        //h - more normal
        //H - all normal
        //m - equal normal and malignant
        //t - more tumour
        //T - all tumour
        //N - all necrotic

        String txt;
        if (isNecrotic) {
            txt = "N";
        } else if ((malignant == 0) && (normal > 0)) {
            txt = "H";
        } else if ((normal == 0) && (malignant > 0)) {
            txt = "T";
        } else if ((healthyNormal > healthyMalignant)
                && (malignant > 0)) {
            txt = "h";
        } else if ((healthyMalignant > healthyNormal)
                && (normal > 0)) {
            txt = "t";
        } else if ((healthyNormal == healthyMalignant) && (malignant > 0)) {
            txt = "m";
        } else if (totalCellCount == 0) {
            txt = "n"; //flag as empty
        } else {
            txt = "X";
        }
        return txt;
    }
}
