/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

import java.util.Objects;

/**
 *
 * @author panik
 */
public class NeatGene {

    private Integer id;
    private int factorTarget;
    private int factorTolerance;
    private static Integer totalGeneCount=0;

    NeatGene(int i, int f, int t) {
        id = i;
        totalGeneCount++;                
        factorTarget = f;
        factorTolerance = t;
    }
    
    NeatGene(NeatGene g){
        id=g.id;
        totalGeneCount++;
        this.factorTarget=g.factorTarget;
        this.factorTolerance=g.factorTolerance;
    }

    @Override
    public NeatGene clone(){
        return new NeatGene(this);
    }
    
    public double expression(double factorShare) {
        if (factorShare==NeatCell.inActiveFlag){
            return 0; //factorTarget;
        } else if (factorShare == 1.0) {
            return 0;
        } else {
            return 1 - Math.exp(-(factorTarget - (factorShare * factorTarget)));
        }
    }

    public int getGeneID() {
        return id;
    }
    
    public void setGeneID(int i){
        id=i;
    }

    public void mutateGene(int newTarget, int newTolerance) {
        factorTarget = newTarget;
        factorTolerance = newTolerance;
    }

    public int getTarget() {
        return factorTarget;
    }

    public int getTolerance() {
        return factorTolerance;
    }

    public boolean health(double factorValue) {
        return (factorValue < (factorTarget + factorTolerance)) && 
                (factorValue > (factorTarget - factorTolerance));
    }

    @Override
    public String toString() {
        return factorTarget + ":" + factorTolerance + ":"; //"id" + id + ":" + 
    }
    
    public static String describe() {
        return "Target:Tolerance:"; //Id:
    }
    
    public static String describe(int count) {
        String s="";
        for (int i=0;i<count;i++){
//            s+= describe();
            s+="Target" + i + ":Tolerance" + i + ":";
        }
        return s;
    }
    
    public static int getTotalGeneCount(){
        return totalGeneCount;
    }
    
    @Override
    public int hashCode(){
        return this.toString().hashCode();
    }

    @Override
    public boolean equals(Object obj) {
//        final double tc=1.0e-6;
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final NeatGene other = (NeatGene) obj;
        if (!Objects.equals(this.id, other.id)) {
            return false;
        }
        if (this.factorTarget != other.factorTarget) {
            return false;
        }
        if (this.factorTolerance != other.factorTolerance) {
            return false;
        }
        return true;
    }
    
    public double getDistance(NeatGene otherGene){
        double deltaTarget=Math.pow((this.factorTarget-otherGene.factorTarget)
                , 2.0);
        double deltaTol=Math.pow((this.factorTolerance-otherGene.factorTolerance)
                , 2.0);
        return deltaTarget + deltaTol;
    }
    
}
