/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

/**
 *
 * @author panik
 */
import ec.util.MersenneTwisterFast;
import java.util.*;

public class NeatGenome {

    private int geneCount;
    protected NeatGene[] genes;
    public static MersenneTwisterFast rand
            = NeatUtils.getRand();

    NeatGenome(int count, int age, NeatGene gene) {
        geneCount = count;
        genes = new NeatGene[geneCount];

        for (int i = 0; i < geneCount; i++) {
            gene.setGeneID(i);
            genes[i] = new NeatGene(gene);
        }
    }

    NeatGenome(int count, int age, int[] target, int tolerance[]) {
        geneCount = count;
        genes = new NeatGene[geneCount];

        for (int i = 0; i < geneCount; i++) {
            if (target.length != geneCount) {
                genes[i] = new NeatGene(i, target[0], tolerance[0]);
            } else {
                genes[i] = new NeatGene(i, target[i], tolerance[i]);
            }
        }
    }

    NeatGenome() {
        //Empty constructor...
    }

    public void mutate() {
        int segment = rand.nextInt(geneCount);
        NeatGene gene = genes[segment];
        if (rand.nextBoolean()) {
            int target=NeatUtils.mutateInt(gene.getTarget());
            gene.mutateGene(target, gene.getTolerance());
        } else {
            int tolerance=NeatUtils.mutateInt(gene.getTolerance());
            gene.mutateGene(gene.getTarget(), tolerance);
        }

    }

    public static String describe() {
        return NeatGene.describe();
    }

    public static String describe(int count) {
        return NeatGene.describe(count);
    }

    public double getFitness(double[] factors) {
        if (factors.length != genes.length) {
            System.out.println("Error! Factors and genes not equal size");
            return -1.0;
        } else {
            double fitness = 0;
            for (int i = 0; i < geneCount; i++) {
                if (factors[i] != NeatCell.inActiveFlag) {
                    double diff= genes[i].getTarget() - 
                            (factors[i] * genes[i].getTarget());
                    diff = Math.abs(diff) / genes[i].getTarget();
                    fitness += diff; //Math.exp(-exponent);

                }
            }

            return fitness;
        }
    }

    public double getRandom() {
        return rand.nextDouble();
    }

    @Override
    public NeatGenome clone() {
        NeatGenome newGenome = new NeatGenome();

        newGenome.geneCount = this.geneCount;
        newGenome.genes = new NeatGene[geneCount];

        for (int i = 0; i < geneCount; i++) {
            newGenome.genes[i] = this.genes[i].clone();
        }

        return newGenome;
    }

    @Override
    public String toString() {
        String s = "";
        for (int i = 0; i < geneCount; i++) {
            s += genes[i].toString();
        }
        return s;
    }

    @Override
    public int hashCode() {
        return this.toString().hashCode();
    }

    @Override
    public boolean equals(Object obj) {
//        final double tc = 1.0e-6;
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final NeatGenome other = (NeatGenome) obj;
        if (this.geneCount != other.geneCount) {
            return false;
        }
        if (!Arrays.deepEquals(this.genes, other.genes)) {
            return false;
        }
        return true;
    }

    public double getDistance(NeatGenome otherGenome) {

        double deltaGenes = 0;
        for (int i = 0; i < geneCount; i++) {
            deltaGenes += this.genes[i].getDistance(otherGenome.genes[i]);
        }
        return deltaGenes; //deltaMutationRate + deltaInvasionRate + 
    }
    
}
