/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

import java.io.FileReader;
import java.util.Arrays;
import java.util.List;
import java.util.Properties;

/**
 *
 * @author panik
 */
public class NeatScenario {

    public Properties props;

    @SuppressWarnings("CallToPrintStackTrace")
    NeatScenario(String f) {
        try (FileReader reader = new FileReader(f)) {
            props = new Properties();
            props.load(reader);
            //let's get rid of leading/trailing spaces
            for(String key : props.stringPropertyNames()){
                String val=props.getProperty(key);
                props.put(key.trim(), val.trim());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    NeatScenario() {
        props = new Properties();
    }

    public void setProp(String param, String val){
            props.setProperty(param, val);
    }
    
    public int getInt(String param, int defVal) {
        if (!props.containsKey(param)) {
            props.setProperty(param, "" + defVal);
            return defVal;
        } else {
            String valS = props.getProperty(param);
            return Integer.parseInt(valS);
        }
    }

    public boolean getBoolean(String param, boolean defVal){
        if (!props.containsKey(param)){
            props.setProperty(param, "" + defVal);
            return defVal;
        } else {
            String valS=props.getProperty(param);
            return Boolean.parseBoolean(valS);
        }
    }
    
    public String getString(String param, String defVal) {
        if (!props.containsKey(param)) {
            props.setProperty(param, defVal);
            return defVal;
        } else {
            return props.getProperty(param);
        }
    }

    public double getDouble(String param, double defVal) {
        if (!props.containsKey(param)) {
            props.setProperty(param, "" + defVal);
            return defVal;
        } else {
            String valS = props.getProperty(param);
            return Double.parseDouble(valS);
        }
    }

    public double[] getDoubleArray(String param, double[] defVal) {
        if (!props.containsKey(param)) {
            String toFormat = "";
            for (int i = 0; i < defVal.length; i++) {
                toFormat += defVal[i] + "|";
            }
            if (toFormat.length() > 0) {
                toFormat = toFormat.substring(0, toFormat.length() - 1);
            }
            props.setProperty(param, "" + toFormat);
            return defVal;
        } else {
            String valS = props.getProperty(param);
            return getDoubleArrayFromString(valS);
        }
    }
       
    public int[] getIntArray(String param, int[] defVal) {
        if (!props.containsKey(param)) {
            String toFormat = "";
            for (int i = 0; i < defVal.length; i++) {
                toFormat += defVal[i] + "|";
            }
            if (toFormat.length() > 0) {
                toFormat = toFormat.substring(0, toFormat.length() - 1);
            }
            props.setProperty(param, "" + toFormat);
            return defVal;
        } else {
            String valS = props.getProperty(param);
            return getIntArrayFromString(valS);
        }
    }

    public char getChar(String param, char defVal) {
        if (!props.containsKey(param)) {
            props.setProperty(param, "" + defVal);
            return defVal;
        } else {
            String valS = props.getProperty(param);
            return valS.charAt(0);
        }
    }

    private double[] getDoubleArrayFromString(String fString) {
        if (fString.length()==0){
            return new double[0];
        }
        int count = 1 + fString.length() - fString.replace("|", "").length();
        double[] factors = new double[count];
        if (count == 1) {
            factors[0] = Double.parseDouble(fString);
            return factors;
        } else {
            String[] sFactors = fString.split("\\|");
            for (int i = 0; i < count; i++) {
                factors[i] = Double.parseDouble(sFactors[i]);
            }
            return factors;
        }
    }

    private int[] getIntArrayFromString(String fString) {
        int count = 1 + fString.length() - fString.replace("|", "").length();
        int[] factors = new int[count];
        if (count == 1) {
            factors[0] = Integer.parseInt(fString);
            return factors;
        } else {
            String[] sFactors = fString.split("\\|");
            for (int i = 0; i < count; i++) {
                factors[i] = Integer.parseInt(sFactors[i]);
            }
            return factors;
        }
    }

    public String printAll() {
        String p = "Scenario Listing:" + System.lineSeparator();
        for (String prop : props.stringPropertyNames()) {
            String v = props.getProperty(prop);
            if (v.startsWith("[D@")) {
                v = prtDoubleArray(prop);
            }
            p += prop + "=" + v + System.lineSeparator();
        }
        return p;
    }

    private String prtDoubleArray(String param) {
        String valS = props.getProperty(param);
        double[] vals = getDoubleArrayFromString(valS);
        String result = "";
        for (int i = 0; i < vals.length; i++) {
            result += vals[i] + " ";
        }
        return result;
    }

    public List<String> toStringArray() {
        String listing = this.printAll();
        return Arrays.asList(listing.split(System.lineSeparator()));
    }
}
