/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

/**
 *
 * @author Pan.Pantziarka
 */
public class StatsRecord {

    private int gen;
    private int healthyGrid;
    private int mixedHealthyGrid;
    private int mixedGrid;
    private int mixedTumourGrid;
    private int tumourGrid;
    private int necroticGrid;
    private int totalCellCount;
    private int totalMalignantCells;
    private int totalNormalCells;
    private int totalHealthyCells;
    private double avgMutationRate;
    private double avgInvasionRate;
    private double avgDistance;
    private double avgMutationCount;
    private double avgNormalFitness;
    private double avgMalignantFitness;
    private double maxMalignantFitness;
    private int poolSize;
    private int treatmentActive;
    private double avgLifeTime;
    private double maxLifeTime;
    private double avgNutrientTarget;
    private double avgNutrientRate;
    private double avgNutrientStore;
    private int handshakeTolerance;
    private double[] avgGeneFactors;
    private double[] avgGeneTargets;
    private double[] avgGeneTolerance;

    StatsRecord(int factorsCount) {
        this.avgGeneFactors = new double[factorsCount];
    }

    public String describe() {
        String out = "Gen|Healthy|mixedHealthy|mixed|mixedTumour|Tumour|Necrotic|"
                + "Total Cells|Malignant Cells|Normal Cells|Healthy Cells|"
                + "Mutation %|Invasion %|Distance|MutCount|Norm Fit|"
                + "Malig Fit|Pool|Treatment|AvgLife|MedLife|"
                + "Nut Target|Nut Rate|Nut Store|Handshake Tol|";
        for (int i = 0; i < avgGeneFactors.length; i++) {
            out += "Factor" + i + "|";
        }
        for (int i = 0; i < avgGeneTargets.length; i++) {
            out += "Target" + i + "|";
            out += "Tol" + i + "|";
        }
        return out.substring(0, out.length() - 1);
    }

    @Override
    public String toString() {
        String out = gen + "|" + healthyGrid + "|" + mixedHealthyGrid + "|";
        out += mixedGrid + "|" + mixedTumourGrid + "|" + tumourGrid + "|";
        out += necroticGrid + "|" + totalCellCount + "|" + totalMalignantCells
                + "|" + totalNormalCells + "|" + totalHealthyCells + "|"
                + avgMutationRate + "|" + avgInvasionRate + "|"
                + avgDistance + "|" + avgMutationCount
                + "|" + avgNormalFitness
                + "|" + avgMalignantFitness + "|" + getPoolSize() + "|"
                + getTreatmentActive() + "|" + getAvgLifeTime() + "|"
                + getMaxLifeTime() + "|";
        out += getAvgNutrientTarget() + "|" + getAvgNutrientRate() + "|";
        out += getAvgNutrientStore() + "|" + handshakeTolerance + "|";

        for (int i = 0; i < avgGeneFactors.length; i++) {
            out += avgGeneFactors[i] + "|";
        }

        for (int i = 0; i < avgGeneTargets.length; i++) {
            out += avgGeneTargets[i] + "|";
            out += avgGeneTolerance[i] + "|";
        }

        return out.substring(0, out.length() - 1);
    }

    public double[] getAvgGeneFactors() {
        return avgGeneFactors;
    }

    public void setAvgGeneFactors(double[] factors) {
        this.avgGeneFactors = factors;
    }

    public double[] getAvgGeneTargets() {
        return avgGeneTargets;
    }

    public void setAvgGeneTargets(double[] targets) {
        this.avgGeneTargets = targets;
    }

    public double[] getAvgGeneTolerance() {
        return avgGeneTolerance;
    }

    public void setAvgGeneTolerance(double[] tolerance) {
        this.avgGeneTolerance = tolerance;
    }

    public int getGen() {
        return gen;
    }

    /**
     * @param gen the gen to set
     */
    public void setGen(int gen) {
        this.gen = gen;
    }

    /**
     * @return the healthyGrid
     */
    public int getHealthyGrid() {
        return healthyGrid;
    }

    /**
     * @param healthyGrid the healthyGrid to set
     */
    public void setHealthyGrid(int healthyGrid) {
        this.healthyGrid = healthyGrid;
    }

    /**
     * @return the mixedHealthyGrid
     */
    public int getMixedHealthyGrid() {
        return mixedHealthyGrid;
    }

    /**
     * @param mixedHealthyGrid the mixedHealthyGrid to set
     */
    public void setMixedHealthyGrid(int mixedHealthyGrid) {
        this.mixedHealthyGrid = mixedHealthyGrid;
    }

    /**
     * @return the mixedGrid
     */
    public int getMixedGrid() {
        return mixedGrid;
    }

    /**
     * @param mixedGrid the mixedGrid to set
     */
    public void setMixedGrid(int mixedGrid) {
        this.mixedGrid = mixedGrid;
    }

    /**
     * @return the mixedTumourGrid
     */
    public int getMixedTumourGrid() {
        return mixedTumourGrid;
    }

    /**
     * @param mixedTumourGrid the mixedTumourGrid to set
     */
    public void setMixedTumourGrid(int mixedTumourGrid) {
        this.mixedTumourGrid = mixedTumourGrid;
    }

    /**
     * @return the tumourGrid
     */
    public int getTumourGrid() {
        return tumourGrid;
    }

    /**
     * @param tumourGrid the tumourGrid to set
     */
    public void setTumourGrid(int tumourGrid) {
        this.tumourGrid = tumourGrid;
    }

    /**
     * @return the necroticGrid
     */
    public int getNecroticGrid() {
        return necroticGrid;
    }

    /**
     * @param necroticGrid the necroticGrid to set
     */
    public void setNecroticGrid(int necroticGrid) {
        this.necroticGrid = necroticGrid;
    }

    /**
     * @return the totalCellCount
     */
    public int getTotalCellCount() {
        return totalCellCount;
    }

    /**
     * @param totalCellCount the totalCellCount to set
     */
    public void setTotalCellCount(int totalCellCount) {
        this.totalCellCount = totalCellCount;
    }

    /**
     * @return the avgMutationRate
     */
    public double getAvgMutationRate() {
        return avgMutationRate;
    }

    /**
     * @param avgMutationRate the avgMutationRate to set
     */
    public void setAvgMutationRate(double avgMutationRate) {
        this.avgMutationRate = avgMutationRate;
    }

    public double getAvgInvasionRate() {
        return avgInvasionRate;
    }

    public void setAvgInvasionRate(double avgInvasionRate) {
        this.avgInvasionRate = avgInvasionRate;
    }

    /**
     * @return the totalMalignantCells
     */
    public int getTotalMalignantCells() {
        return totalMalignantCells;
    }

    /**
     * @param totalMalignantCells the totalMalignantCells to set
     */
    public void setTotalMalignantCells(int totalMalignantCells) {
        this.totalMalignantCells = totalMalignantCells;
    }

    /**
     * @return the totalNormalCells
     */
    public int getTotalNormalCells() {
        return totalNormalCells;
    }

    /**
     * @param totalNormalCells the totalNormalCells to set
     */
    public void setTotalNormalCells(int totalNormalCells) {
        this.totalNormalCells = totalNormalCells;
    }

    /**
     * @return the totalHealthyCells
     */
    public int getTotalHealthyCells() {
        return totalHealthyCells;
    }

    /**
     * @param totalHealthyCells the totalHealthyCells to set
     */
    public void setTotalHealthyCells(int totalHealthyCells) {
        this.totalHealthyCells = totalHealthyCells;
    }

    /**
     * @return the poolSize
     */
    public int getPoolSize() {
        return poolSize;
    }

    /**
     * @param poolSize the poolSize to set
     */
    public void setPoolSize(int poolSize) {
        this.poolSize = poolSize;
    }

    /**
     * @return the treatmentActive
     */
    public int getTreatmentActive() {
        return treatmentActive;
    }

    /**
     * @param treatmentActive the treatmentActive to set
     */
    public void setTreatmentActive(boolean treatmentActive) {
        if (treatmentActive) {
            this.treatmentActive = 1;
        } else {
            this.treatmentActive = 0;
        }
    }

    /**
     * @return the avgDistance
     */
    public double getAvgDistance() {
        return avgDistance;
    }

    /**
     * @param avgDistance the avgDistance to set
     */
    public void setAvgDistance(double avgDistance) {
        this.avgDistance = avgDistance;
    }

    public double getAvgMutationCount() {
        return avgMutationCount;
    }

    public void setAvgMutationCount(double avgMutCount) {
        this.avgMutationCount = avgMutCount;
    }

    /**
     * @return the avgNormalFitness
     */
    public double getAvgNormalFitness() {
        return avgNormalFitness;
    }

    public double getPeakNormalFitness() {
        return avgNormalFitness;
    }

    /**
     * @param avgNormalFitness the avgNormalFitness to set
     */
    public void setAvgNormalFitness(double avgNormalFitness) {
        this.avgNormalFitness = avgNormalFitness;
    }

    /**
     * @return the avgMalignantFitness
     */
    public double getAvgMalignantFitness() {
        return avgMalignantFitness;
    }

    public double getMaxMalignantFitness() {
        return maxMalignantFitness;
    }

    public void setAvgMalignantFitness(double avgMalignantFitness) {
        this.avgMalignantFitness = avgMalignantFitness;
    }

    public void setMaxMalignantFitness(double maxMalignantFitness) {
        this.maxMalignantFitness = maxMalignantFitness;
    }

    public void setAvgLifeTime(double avgLife) {
        this.avgLifeTime = avgLife;
    }

    public double getAvgLifeTime() {
        return avgLifeTime;
    }

    public void setMaxLifeTime(double medLife) {
        this.maxLifeTime = medLife;
    }

    public double getMaxLifeTime() {
        return maxLifeTime;
    }

    public void setAvgNutrientTarget(double target) {
        this.avgNutrientTarget = target;
    }

    public double getAvgNutrientTarget() {
        return avgNutrientTarget;
    }

    public void setAvgNutrientRate(double rate) {
        this.avgNutrientRate = rate;
    }

    public double getAvgNutrientRate() {
        return avgNutrientRate;
    }

    public void setAvgNutrientStore(double store) {
        this.avgNutrientStore = store;
    }

    public double getAvgNutrientStore() {
        return avgNutrientStore;
    }
    
    public void setHandshakeTolerance(int tol){
        this.handshakeTolerance=tol;
    }
    
    public int getHandshakeTolerance() {
        return this.handshakeTolerance;
    }
}
