/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

/**
 *
 * @author Pan.Pantziarka
 */
public class StrategyInhibitor extends StrategyChemo {

    private int[] factorsToBlock;
    private double[] factorValues;

    StrategyInhibitor() {
        super();
    }

    @Override
    public double[] agePopulation(GridElement gE, int nutrientSupply,
            double[] gFactorSupply) {

        prepareNutrientAndFactors(nutrientSupply, gE, gFactorSupply);        
        
        //Now apply the inhibitor
//        if (factorsToBlock.length > 0) {
//            for (int i = 0; i < factorsToBlock.length; i++) {
//                shareOfFactors[factorsToBlock[i]] = NeatCell.inActiveFlag;
//            }
//        }
        
        

        //Age the whole population - based on food and factors
        for (NeatCell eaCell : gE.eaCells.values()) {
            if (eaCell.getState() == CellState.HEALTHY) {
                eaCell.feedCell(nutrient * eaCell.getNutrientTarget());
                eaCell.processFactors(shareOfFactors);
                eaCell.updateFitness(shareOfFactors);
            }
            eaCell.changeState(gE.gridIsNecrotic);
        }
        return shareOfFactors;
    }

    @Override
    public void setSchedule(NeatScenario schedule) {
        this.schedule = schedule;
        treatmentDurationGen = schedule.getInt("treatmentDurationGen", 0);
        factorsToBlock = new int[0];
        factorsToBlock = schedule.getIntArray("factorsToBlock", factorsToBlock);
        factorValues=new double[0];
        factorValues=schedule.getDoubleArray("factorValues", factorValues);
    }
    
    
    @Override
    protected void prepareNutrientAndFactors(int nutrientSupply, GridElement gE,
            double[] gFactorSupply) {
        
        //Now apply the inhibitor
        if (factorsToBlock.length > 0) {
            for (int i = 0; i < factorsToBlock.length; i++) {
                gFactorSupply[factorsToBlock[i]] = factorValues[i];
            }
        }        
        
        super.prepareNutrientAndFactors(nutrientSupply, gE, gFactorSupply);
    }
    
}
