/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

/**
 *
 * @author panik
 */
public class StrategyNutrientChemo extends TreatmentStrategy {

    protected boolean haveCrossedInvasionThreshold = false;
    protected int lastTreatmentGen = -1;
    protected int treatmentCount = -1;
    protected int treatmentDurationGen;
    protected int treatmentMalignantCutoff;
    protected int treatmentNormalCutoff;
    protected int treatmentNutrientSupply;

    @Override
    public double[] agePopulation(GridElement gE, int nutrientSupply,
            double[] gFactorSupply) {

        prepareNutrientAndFactors(treatmentNutrientSupply, gE, gFactorSupply);

        //Age the whole population - based on food and factors
        for (NeatCell eaCell : gE.eaCells.values()) {
            if (eaCell.getState() == CellState.HEALTHY) {
                eaCell.feedCell(nutrient * eaCell.getNutrientTarget());
                eaCell.processFactors(shareOfFactors);
                eaCell.updateFitness(shareOfFactors);
            }
            if (eaCell.getType() == CellType.MALIGNANT) {
//                if ((eaCell.getState() == CellState.HEALTHY)
//                        && (eaCell.getClock() < treatmentMalignantCutoff)) {
                if (eaCell.getClock() < treatmentMalignantCutoff) {
                    eaCell.setClock(0);
                    eaCell.setState(CellState.TO_BE_CLEARED);
                }
            } else {
                if (eaCell.getClock() < treatmentNormalCutoff) {
                    eaCell.setClock(0);
                    eaCell.setState(CellState.TO_BE_CLEARED);
//                    eaCell.changeState(gE.gridIsNecrotic);
                }
            }
        }
        return shareOfFactors;
    }

    @Override
    public boolean trigger(int currentGen, double currentInvasion) {

        if (haveCrossedInvasionThreshold) {
            if (lastTreatmentGen != currentGen) {
                lastTreatmentGen = currentGen;
                treatmentCount++;
            }
            if (treatmentCount < treatmentDurationGen) {
                isActive = true;
            } else {
                isActive = false;
            }
            return isActive;
        }

        boolean clock;
        if (treatmentDurationGen != 0) {
            clock = (gen <= currentGen)
                    && (currentGen < (gen + treatmentDurationGen));
        } else {
            clock = gen <= currentGen;
        }

        boolean spread = invasion <= currentInvasion;
        if ((spread == true) && (invasion != 0)) {
            haveCrossedInvasionThreshold = true;
        }

        if (gen == 0) {
            isActive = spread || haveCrossedInvasionThreshold;
        } else if (invasion == 0) {
            isActive = clock;
        } else {
            isActive = (spread || clock);
        }

        return isActive;
    }

    @Override
    public void setSchedule(NeatScenario schedule) {
        this.schedule = schedule;
        treatmentDurationGen = schedule.getInt("treatmentDurationGen", 0);
        treatmentMalignantCutoff
                = schedule.getInt("treatmentMalignantCutoff", 20);
        treatmentNormalCutoff = schedule.getInt("treatmentNormalCutoff", 10);
        treatmentNutrientSupply
                = schedule.getInt("treatmentNutrientSupply", 10);
    }

}
