/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

/**
 *
 * @author Pan.Pantziarka
 */
public class StrategyPulsedChemo extends StrategyChemo {
    
    private int treatmentDurationOnPeriod;
    private int treatmentDurationOffPeriod;
    private static int treatmentCycle;
    private static int treatmentCycles;
    
    public StrategyPulsedChemo(){
        super();
        treatmentCycle=0;
    }
    
    @Override
    public boolean trigger(int currentGen, double currentInvasion) {
        
        if (haveCrossedInvasionThreshold){
            if (lastTreatmentGen!=currentGen){
                lastTreatmentGen=currentGen;
            }
            if (onPeriod(0, treatmentDurationOnPeriod, 
                    treatmentDurationOffPeriod, currentGen)){
                isActive=true;
            } else {
                isActive=false;
            }
            return isActive;
        }
        
        boolean clock;
        if (gen!=0){
            clock = (gen <= currentGen)  && 
                    (onPeriod(gen, treatmentDurationOnPeriod, 
                    treatmentDurationOffPeriod, currentGen));
        } else {
            clock = gen <= currentGen;            
        }
        
        boolean spread = invasion <= currentInvasion;
        if ((spread==true) && (invasion!=0)){
            haveCrossedInvasionThreshold=true;
        }

        if (gen == 0) {
            isActive = spread || haveCrossedInvasionThreshold;
        } else if (invasion == 0) {
            isActive = clock;
        } else {
            isActive = (spread || clock);
        }
        
        return isActive;
    }   
    
    @Override
    public void setSchedule(NeatScenario schedule) {
        this.schedule=schedule;
        treatmentDurationOffPeriod=
                schedule.getInt("treatmentDurationOffPeriod", 100);
        treatmentDurationOnPeriod=
                schedule.getInt("treatmentDurationOnPeriod", 100);        
        treatmentMalignantCutoff=
                schedule.getInt("treatmentMalignantCutoff", 20);
        treatmentNormalCutoff=schedule.getInt("treatmentNormalCutoff", 10);
        treatmentCycles=schedule.getInt("treatmentCycles", 1);
    }
    
    public static boolean onPeriod(int start, int on, int off, int gen) {
        int cyclePosition = (gen - start) % (on + off);

        if ((cyclePosition >= 0) && (cyclePosition < on)) {
            treatmentCycle=((gen - start)/(on + off));
            if (treatmentCycle>(treatmentCycles-1)){
                return false;
            }
            return true;
        } else if ((cyclePosition >= on) && (cyclePosition < off)) {
            return false;
        } else {
            return false;
        }
    }
    
}
